//
//  Element.swift
//  Swiftement Pokemon
//
//  Created by Onoulade on 16/01/2022.
//

import Foundation

/*
 Juste une petite énumération de chaque élément ainsi que les multiplicateurs d'efficacité
 ainsi que la vérification d'efficacité d'un élément sur un autre
 */

enum Element {
    case pierre
    case feuille
    case ciseaux
    
    static let multipleEfficacite: Float = 2
    static let diviseurEfficacite: Float = 0.5
    
    static func efficace(_ elem1: Element, sur elem2: Element) -> Bool? {
        switch (elem1, elem2) {
        case (.feuille, .pierre):
            return true
        case (.pierre, .ciseaux):
            return true
        case (.ciseaux, .feuille):
            return true
        case (.feuille, .ciseaux):
            return false
        case (.pierre, .feuille):
            return false
        case (.ciseaux, .pierre):
            return false
        default:
            return nil
        }
    }
}
